#include <ldas_tools_config.h>

#include "Cache/ExcludedDirectoriesSingleton.hh"

#include "MountPointManagerSingleton.hh"

#include "DirectoryManagerSingleton.hh"

namespace
{
  static void
  on_excluded_directories_update( )
  {
  }
}

namespace diskCache
{
  DEFINE_READ_WRITE_SINGLETON_NO_CONSTRUCTOR(MountPointManagerSingleton,80)

  /** \cond ignore_singleton_constructor */
  MountPointManagerSingleton::
  MountPointManagerSingleton( )
  {
    DEFINE_READ_WRITE_SINGLETON_CONSTRUCTOR_BODY(MountPointManagerSingleton);

    //-------------------------------------------------------------------
    // Record the address of the instance
    //-------------------------------------------------------------------
    MountPointManager::
      DirectoryCache( &(DirectoryManagerSingleton::Instance( )) );
    //-------------------------------------------------------------------
    // Be informed when the list of excluded directories is updated
    //-------------------------------------------------------------------
    Cache::ExcludedDirectoriesSingleton::
      OnUpdate( on_excluded_directories_update );
  }
  /** \endcond */

}
