#ifndef FrameApiAdcDataHH
#define FrameApiAdcDataHH

#include <deque>
#include <list>
#include <string>

#include "framecpp/FrAdcData.hh"
#include "framecpp/Time.hh"

#include "genericAPI/swigexception.hh"

namespace FrameAPI
{
  namespace FrAdcData
  {
    void appendAuxData( FrameCPP::FrAdcData& Dest,
			const FrameCPP::FrAdcData& Source );

    FrameCPP::FrAdcData* cloneHeader( const FrameCPP::FrAdcData& Source );

    FrameCPP::FrAdcData* concat( const std::list< FrameCPP::Object* >& Segment );

  }
}

bool
areAdcsCompatable( const FrameCPP::FrAdcData& Adc1,
		   const FrameCPP::FrAdcData& Adc2 );

FrameCPP::FrAdcData*
concatAdcData( std::list< const FrameCPP::FrAdcData* > AdcData );
#endif // FrameApiAdcDataHH
